// -*- mode: C++; tab-width: 4; indent-tabs-mode: nil -*- (for GNU Emacs)
#ifndef _datapipe_h_
#define _datapipe_h_

struct datapipe_entry;

typedef struct datapipe {
	struct datapipe_entry *first, *last;
	KSPIN_LOCK guard;
} datapipe_t;

void datapipe_init(datapipe_t *dp);
void datapipe_free(datapipe_t *dp);

ULONG datapipe_peek(datapipe_t *dp);
ULONG datapipe_get(datapipe_t *dp, char *buf, ULONG size);

NTSTATUS datapipe_push(datapipe_t *dp, const char *data, ULONG size);

#endif
