#ifndef _memtrack_h_
#define _memtrack_h_

#define MEM_TAG		'1VRD'

#ifdef _DEBUG

void memtrack_init();
void memtrack_free();

void *mt_malloc(ULONG size, const char *file, ULONG line);
#define malloc(size)	mt_malloc((size), __FILE__, __LINE__)	

void free(void *ptr);

#else

#define memtrack_init()
#define memtrack_free()

#define malloc(size)	ExAllocatePoolWithTag(NonPagedPool, (size), MEM_TAG)
#define free(ptr)		ExFreePool(ptr)

#endif

#endif
